<?php
/**
 * CLink License Media
 *
 * CLink license media
 *
 * @package CLink
 * @subpackage System
 */
 
// Direct Access Not Allowed
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
/**
 * CLink Display Showcase for Image
 *
 * @param integer attachment_id attachment id
 * @return string html
 */
function wpclink_display_image_showcase($attachment_id = 0){
	$image_url = wp_get_attachment_url($attachment_id);
	return '<img src="'.$image_url.'" class="img showcase" />';
}
/**
 * CLink Display Showcase for all Medias
 *
 * @param integer attachment_id attachment id
 * @return string html
 */
function wpclink_display_media_showcase($attachment_id = 0){
	$type = get_post_mime_type($attachment_id);
	switch ($type) {
    case 'image/jpeg':
		return wpclink_display_image_showcase($attachment_id);
    case 'image/png':
    case 'image/gif':
    case 'video/mpeg':
    case 'video/mp4': 
    case 'video/quicktime':
    case 'text/csv':
    case 'text/plain': 
    case 'text/xml':
    default:
  }
}
/**
 * CLink Reuse Offer Popup
 * 
 * @param integer attachment_id attachment id
 */
function wpclink_do_popup_link_media($attachment_id = 0) {
	// If import mode only
	if(wpclink_import_mode()) return false;
	// if content is not in linked list
	if(wpclink_is_post_referent($attachment_id)){
		// OK
	}else{
		return false;
	}
	$token = uniqid();
?>
<div id="CLModal" class="cl_modal">
  <div class="cl_modal-content">
    <span class="cl_close">&times;</span>
<div id="confirm-box">
<p class="style1"><?php _e('The reuse of this content is enabled for WordPress powered sites using wpCLink plugin','cl_text'); ?></p>
<p class="style2"><?php _e('Click Download below to get it or Continue <br />if you have it already installed','c l_text'); ?></p>
<p class="confirm-btn"><a class="cl_download" href="https://wordpress.org/plugins/wpclink/"><?php _e('Download','cl_text'); ?></a> <a class="cl_download continue"><?php _e('Continue','cl_text'); ?></a></p><p class="style3"><a target="_blank" href="https://licenses.clink.id/personal/0-9i/"><?php _e('License Terms and Conditions','cl_text'); ?> <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><rect x="0" fill="none" width="20" height="20"/><g><path d="M9 3h8v8l-2-1V6.92l-5.6 5.59-1.41-1.41L14.08 5H10zm3 12v-3l2-2v7H3V6h8L9 8H5v7h7z"/></g></svg></a></p>
</div>
<form id="cl_new_offer_clinkid" action="">
<div id="cl_offer_response">
<p class="style1"><?php _e('The content will be accessible at the Creations &rarr; Linked menu  in your WordPress instance after you accept the Terms and Conditions of the License.','cl_text'); ?></p>
<p class="description style2"><?php _e('Please Log Into your WordPress Instance','cl_text'); ?></p>
<p class="description style2"><?php _e('Enter your Website URL','cl_text'); ?></p>
<input id="cl_weburl" required="required" value="" autofocus="autofocus" placeholder="Website Address" type="url">
<input type="hidden" id="cl_popup_id" value="<?php echo $token; ?>" />
<div class="quick-response"></div>
<?php /* <p class="divider-or"><span>or</span></p>
 <p><a class="go_care"><span class="cico"></span>Sign In with CLink</a></p> */ ?>
<input style="visibility:hidden" class="content_type" type="checkbox" name="content_type" checked="checked" value="single" />
<input type="hidden" name="cl_auto_code" id="cl_auto_code" value="" />
<?php if ( $group_found = wpclink_get_option('wpclink_group') ) {
if(!empty($group_found['url'])){ ?>
<p class="style3"><a class="additional-btn" href="#"><strong>+</strong> <?php _e('Available Options','cl_text'); ?></a></p>
<div class="additional_option">
<ul>
  <li>
    <label class="container_check"><?php _e('Join Group','cl_text'); ?>
  <input class="content_type" type="checkbox" name="content_type" value="group">
  <span class="checkmark"></span>
</label>
  </li>
</ul>
</div>
<?php }
} ?>
<div id="wait"></div>
<input id="cl_modal_submit" value="Get a license" type="submit">
</div>
</form>		
    <input type="hidden" name="auto_content" id="auto_content" value="<?php echo $attachment_id ?>" />
</div>
</div>
<?php }
// Register clink reuse offer popup function
add_action( 'wpclink_media_footer', 'wpclink_do_popup_link_media',10,1 );

/**
 * CLink Load License
 * 
 */
function wpclink_load_license(){
	
$media_id = $_GET['id'];
	
if (is_numeric($media_id)) {
    if($media_id == 0){
			die('ERROR: 404 Not Found');
	}else{
	}
} else {
    die('ERROR: 400 Invalid Command');
}

// Style
$style_showcase = plugins_url('public/css/media-showcase.css?'.uniqid('_'),dirname(__FILE__));
$style_frontend = plugins_url('public/css/frontend.css?'.uniqid('_'),dirname(__FILE__));
$style_modal = plugins_url('public/css/modal.css?'.uniqid('_'),dirname(__FILE__));
	
$styles_list = array($style_showcase,
					 $style_frontend,
					 $style_modal);
$stylesheet = '';
foreach($styles_list  as $style_signle){
	$stylesheet .='<link href="'.$style_signle.'" rel="stylesheet">';	
}

$contentID = get_post_meta( $media_id, 'wpclink_creation_ID', true );
	
?><!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<?php echo $stylesheet; ?>
<?php wp_head(); ?>  
</head>
<body class="custom-background-image">
<div class="media-container">
<div id="media"><?php echo wpclink_display_media_showcase($media_id) ?></div>
<div id="reuse"><div class="more-links"><img src="<?php echo plugins_url( 'public/images/info.svg?aa', dirname(__FILE__) ) ; ?>" /><div class="ul-links"><li><?php 
		$contentID = get_post_meta( $media_id, 'wpclink_creation_ID', true );
		echo '<a class="cl-clinkid" target="_blank" href="'.WPCLINK_ID_URL.'/#objects/'.$contentID.'">Provenance and rights</a>'; ?></li><?php do_action('wpclink_media_links',$media_id); ?></div></div><?php echo wpclink_media_reuse_button(); ?> </div> 
</div><?php do_action('wpclink_media_footer',$media_id); ?>
<?php wp_footer(); ?>  
</body>
</html><?php
}

/**
 * CLink Media License URL
 * 
 */
function wpclink_start_media_license(){
		if(isset($_GET['clink_media_license'])){
			wpclink_load_license();
			die();
		}
}
// Register generate xml url function on wordpress load
add_action('wp_loaded','wpclink_start_media_license');
