<?php
/**
 * CLink Reuse Functions 
 *
 * CLink reuse popup functions
 *
 * @package CLink
 * @subpackage Link Manager
 */
 
 // Direct Access Not Allowed
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );

/**
 * CLink Popup Agreement URL Display
 * 
 * @param string $weburl site address
 * 
 */
function wpclink_offer_popup_link($weburl){
	
	global $wpdb;
	
	// GET IP
	$url = parse_url($weburl);
	$host_url = $url['host'];
	
	// PICK IP
	$ip = gethostbyname($host_url);
	
	// Table Prefix
    $table_name_token = $wpdb->prefix . 'wpclink_tokens'; 
	
	
	/* INSERT TOKEN IN DATABASE */
	$token_key = wpclink_go_live_link(8);
	$web_address = $weburl;
	$ip_address = $ip;
	
	$record_found = $wpdb->get_row( 'SELECT * FROM '.$table_name_token.' WHERE linked_site_url = "'.$web_address.'" AND token_expiration <> 1' );
	
	if ( $record_found !== NULL ) {
		$token_key = $record_found->token;
	}else{
		// INSERT
		$wpdb->insert($table_name_token,
				array(	'linked_site_url' => $web_address,
						'linked_site_domain' => $host_url,
						'token' => $token_key,
						'linked_site_IP' => $ip_address,
						'license_delivery_date' => '',
						'token_expiration' => '0'));
	}
	
		echo '<div id="cl_step2" class="cl_step">
			<h2>CLink Agreement URL</h2>
			<h3>Put this url in your clink to start </h3>
			<input id="cl_weburl" required="required" autofocus="autofocus" value="'.wpclink_get_token_url($token_key).'" type="url">
			</div>';
}
add_action('cl_offer_popup','wpclink_offer_popup_link',10,1);
/**
 * CLink Reuse Popup Agreement URL Display
 * 
 * @param string $weburl site address
 * @param string $content_type content type uc-ut-um | uc-at-um
 * @param string $content_url url of the current post
 * 
 */
function wpclink_generate_token_link($weburl, $content_type = false, $content_url = false){
	
	global $wpdb;
	
	// GET IP
	$url = parse_url($weburl);
	$host_url = $url['host'];
	
	// PICK IP
	$ip = gethostbyname($host_url);
	
	// Table Prefix
    $table_name_token = $wpdb->prefix . 'wpclink_tokens'; 
	
	// CONTENT TYPE
	$content_type = $content_type;
	
	// CONTENT URL TO POST ID
	$get_media_id = parse_url($content_url);

	if(isset($get_media_id['query'])){

		parse_str($get_media_id['query'], $media_query_id);

		if(isset($media_query_id['id'])){
		   $postid = $media_query_id['id'];
		}else{
		   $content_url = str_replace('&clink=offer','',$content_url);
			$postid = url_to_postid( $content_url );
		}

	}else{
		$content_url = str_replace('&clink=offer','',$content_url);
		$postid = url_to_postid( $content_url );
	}
	
	
	
	/* INSERT TOKEN IN DATABASE */
	$token_key = wpclink_go_live_link(8);
	$web_address = $weburl;
	$ip_address = $ip;
	
	$record_found = $wpdb->get_row( 'SELECT * FROM '.$table_name_token.' WHERE post_id = "'.$postid.'" AND token_expiration <> 1' );
	
	if ( $record_found !== NULL ) {
		$token_key = $record_found->token;
	}else{
		// INSERT
		$wpdb->insert($table_name_token,
				array(	'linked_site_url' => $web_address,
						'linked_site_domain' => $host_url,
						'token' => $token_key,
						'linked_site_IP' => $ip_address,
						'token_type' => $content_type,
						'post_id' => $postid,
						'license_delivery_date' => '',
						'token_expiration' => '0',
						'creation_uri' => $content_url));
	}
	
echo '<input id="reuse_token_key" class="startlink"  value="'.wpclink_get_token_url($token_key).'" type="hidden">';
	
}
add_action('cl_offer_popup_clinkid','wpclink_generate_token_link',10,3);
/**
 * CLink Reuse Next Button
 *
 */
function wpclink_offer_popup_next_func(){
	echo '<a id="next_step2" class="cl_download" href="#">Next</a>';
}
// Register reuse next button
add_action('cl_offer_popup_next_link','wpclink_offer_popup_next_func');
/**
 * CLink Reuse Button Redirect to orgin of content url
 * 
 */
function wpclink_redirect_to_origin(){
	if(isset($_GET['clink']) and $_GET['clink'] == 'offer'){
		
		global $post;
		$post_id = $post->ID;
		if($origin_url = get_post_meta($post_id,'wpclink_referent_post_uri',true)){			
			$rediect_me = add_query_arg( 'clink', 'offer', $origin_url );
			 wp_redirect( $rediect_me );
        	 die;
		}
	}
}
// Register reuse button redirect to origin content on redirection template
add_action( 'template_redirect', 'wpclink_redirect_to_origin' );
/**
 * CLink Get Global ID of Post
 * 
 * @return integer post id
 */
function wpclink_global_id() {
	// For Media
  if(isset($_GET['clink_media_license']) and isset($_GET['id']) and is_numeric($_GET['id'])){  
	  return $_GET['id'];
  }
	
  if ( in_the_loop() ) {
    $post_id = get_the_ID();
  } else {
    /** @var $wp_query wp_query */
    global $wp_query;
    $post_id = $wp_query->get_queried_object_id();
    }
  return $post_id;
}
/**
 * CLink Content is Refernet List Published
 * 
 * 
 * @return boolean
 */
function wpclink_is_post_referent($post_id = 0){
	if($post_id == 0){
		$post_id = wpclink_global_id();
	}
	
	if($contentID = get_post_meta( $post_id, 'wpclink_creation_ID', true )){
		
		$registered_list_post = wpclink_get_option('referent_posts');
		$registered_list_page = wpclink_get_option('referent_pages');
		$registered_list_attachment = wpclink_get_option('referent_attachments');
		
		
		if(!is_array($registered_list_post)) $registered_list_post = array();
			if(!is_array($registered_list_page)) $registered_list_page = array();
				if(!is_array($registered_list_attachment)) $registered_list_attachment = array();
			
		
		$registered_complete = array();
		
		if(is_array($registered_list_post)){
			$registered_complete = array_merge($registered_list_post,$registered_complete);
		}
		if(is_array($registered_list_page)){
			$registered_complete = array_merge($registered_list_page,$registered_complete);
		} 
		if(is_array($registered_list_attachment)){
			$registered_complete = array_merge($registered_list_attachment,$registered_complete);
		}
			
		if(in_array($post_id, $registered_complete)){
			return true;
		}
		
		
		
	}
	return false;
}
/**
 * CLink Reuse Offer Popup
 * 
 */
function wpclink_do_popup_link() {
	// If import mode only
	if(wpclink_import_mode()) return false;
	// if content is not in linked list
	if(!wpclink_is_post_referent()) return false;
	$token = uniqid();
?>
<div id="CLModal" class="cl_modal">
  <div class="cl_modal-content">
    <span class="cl_close">&times;</span>
<div id="confirm-box">
<p class="style1"><?php _e('The reuse of this content is enabled for WordPress powered sites using wpCLink plugin','cl_text'); ?></p>
<p class="style2"><?php _e('Click Download below to get it or Continue <br />if you have it already installed','cl_text'); ?></p>
<p class="confirm-btn"><a class="cl_download" href="https://wordpress.org/plugins/wpclink/"><?php _e('Download','cl_text'); ?></a> <a class="cl_download continue"><?php _e('Continue','cl_text'); ?></a></p>
<p class="style3"><a target="_blank" href="https://licenses.clink.id/personal/0-9/"><?php _e('License Terms and Conditions','cl_text'); ?> <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><rect x="0" fill="none" width="20" height="20"/><g><path d="M9 3h8v8l-2-1V6.92l-5.6 5.59-1.41-1.41L14.08 5H10zm3 12v-3l2-2v7H3V6h8L9 8H5v7h7z"/></g></svg></a></p></div>
<form id="cl_new_offer_clinkid" action="">
<div id="cl_offer_response">
<p class="style1"><?php _e('The content will be accessible at the Creations &rarr; Linked menu  in your WordPress instance after you accept the Terms and Conditions of the License.','cl_text'); ?></p>
<p class="description style2"><?php _e('Please Log Into your WordPress Instance','cl_text'); ?></p>
<p class="description style2"><?php _e('Enter your Website URL','cl_text'); ?></p>
<input id="cl_weburl" required="required" value="" autofocus="autofocus" placeholder="Website Address" type="url">
<input type="hidden" id="cl_popup_id" value="<?php echo $token; ?>" />
<div class="quick-response"></div>
<?php /* <p class="divider-or"><span>or</span></p>
 <p><a class="go_care"><span class="cico"></span>Sign In with CLink</a></p> */ ?>
<input style="visibility:hidden" class="content_type" type="checkbox" name="content_type" checked="checked" value="single" />
<input type="hidden" name="cl_auto_code" id="cl_auto_code" value="" />
<?php if ( $group_found = wpclink_get_option('wpclink_group') ) {
if(!empty($group_found['url'])){ ?>
<p class="style3"><a class="additional-btn" href="#"><strong>+</strong> <?php _e('Available Options','cl_text'); ?></a></p>
<div class="additional_option">
<ul>
  <li>
    <label class="container_check"><?php _e('Join Group','cl_text'); ?>
  <input class="content_type" type="checkbox" name="content_type" value="group">
  <span class="checkmark"></span>
</label>
  </li>
</ul>
</div>
<?php }
} ?>
<div id="wait"></div>
<input id="cl_modal_submit" value="Get a license" type="submit">
</div>
</form>		
    <input type="hidden" name="auto_content" id="auto_content" value="<?php echo wpclink_global_id() ?>" />
</div>
</div>
<?php }
// Register clink reuse offer popup function
add_action( 'wp_footer', 'wpclink_do_popup_link' );
/**
 * CLink Reuse Content Button After Post and Page Content
 * 
 * @param string $content default content
 * 
 */
function wpclink_do_clink_ID_with_reuse_button($content){
	
global $post;
$post_id = $post->ID;
	
if (is_single() || is_archive() || is_home() || is_page()) {  
    
	
	$contentID = get_post_meta( $post_id, 'wpclink_creation_ID', true );
	
	$post_orign_creator = get_post_meta( $post_id, 'wpclink_referent_creator_display_name', true );
	$post_orign_creator_id = get_post_meta( $post_id, 'wpclink_referent_creator_party_ID', true );
	
	$post_orign_creator_id_space_removed = str_replace(' ', '', $post_orign_creator_id);
	
	$referent_creator = get_post_meta( $post_id, 'wpclink_referent_creator_party_ID', true );
	
	$registered_list_post = wpclink_get_option('referent_posts');
	$registered_list_page = wpclink_get_option('referent_pages');
	$registered_list_attachment = wpclink_get_option('referent_attachments');
		
	// Fixes
	if(is_array($registered_list_attachment)){
	}else{
		$registered_list_attachment = array();
	}
	
	$reuse_button_left_offset = wpclink_get_option('reuse_button_left_offset');
	$reuse_button_top_offset = wpclink_get_option('reuse_button_top_offset');
	
	if(!empty($reuse_button_left_offset)){
		if(!empty($reuse_button_top_offset)){
			$style_reuse = 'style="margin-right: '.$reuse_button_left_offset.'px; margin-top: '.$reuse_button_top_offset.'px;"';
		}else{
			$style_reuse = 'style="margin-right: '.$reuse_button_left_offset.'px;"';	
		}
	}else{
		if(!empty($reuse_button_top_offset)){
			$style_reuse = 'style="margin-top: '.$reuse_button_top_offset.'px;"';
		}else{
			$style_reuse = '';
		}
	}
	
	
	
	if ( !empty( $contentID ) ) {	
	if(is_single() || is_page()){
		if(is_array($registered_list_post) and is_array($registered_list_page) and is_array($registered_list_attachment)){
			$registered_complete = array_merge($registered_list_page,$registered_list_post,$registered_list_attachment);
		if(in_array($post_id, $registered_complete)){
				if($sync_origin = get_post_meta( $post_id, 'wpclink_referent_post_uri', true )){
				}else{
					
					if(get_post_type($post_id) == "attachment"){
					}else{
					
					$content .= '<p><a class="cl-resuse" '.$style_reuse.' target="_blank">Reuse this content</a></p>';
					}
					
					
				}
		
		}else{
			if($sync_origin = get_post_meta( $post_id, 'wpclink_referent_post_uri', true )){
				
				$content .= '<div class="orgin_post">Originally posted by <a  target="_blank" href="'.WPCLINK_ID_URL.'/#objects/'.$post_orign_creator_id.'">'.$post_orign_creator.'</a></div>';
				if(get_post_type($post_id) == "attachment"){
				}else{
					$content .= '<p><a class="cl-resuse_origin" href="'.$sync_origin.'?clink=offer">Reuse this content</a></p>';
				}
				}else{
				}
			
		}
		}
	}
		
		$content .= '<p><a class="cl-clinkid" target="_blank" href="'.WPCLINK_ID_URL.'/#objects/'.$contentID.'">Provenance and rights</a></p>';
	  }else{
		  
	  }
	
}
    return $content;
}
if(!isset($_GET['_locale'])){
    if ( !is_admin() ) {
// Register clink resue button after post and pages function
add_filter( "the_content", "wpclink_do_clink_ID_with_reuse_button" );
    }    
}

/**
 * CLink Reuse Media Button After Attachment 
 * 
 * @param string $content default content
 * 
 */
function wpclink_media_reuse_button($content = ''){
	
	$post_id = $_GET['id'];
	
	$contentID = get_post_meta( $post_id, 'wpclink_creation_ID', true );
	
	// Attachments
	$registered_list_attachment = wpclink_get_option('referent_attachments');
	
	// Fixes
	if(is_array($registered_list_attachment)){
	}else{
		$registered_list_attachment = array();
	}
	
	if ( !empty( $contentID ) ) {	
		if(is_array($registered_list_attachment)){
			$registered_complete = $registered_list_attachment;
		if(in_array($post_id, $registered_complete)){
			
				if($sync_origin = get_post_meta( $post_id, 'wpclink_referent_post_uri', true )){
				}else{
					$content .= '<a class="cl-resuse" target="_blank">Get a license</a>';
				}
		
		}else{
			if($sync_origin = get_post_meta( $post_id, 'wpclink_referent_post_uri', true )){
				
				$content .= '<div class="orgin_post">Originally posted by <a  target="_blank" href="'.WPCLINK_ID_URL.'/#objects/'.$post_orign_creator_id.'">'.$post_orign_creator.'</a></div>';
				
				$content .= '<a class="cl-resuse_origin" href="'.$sync_origin.'?clink=offer">Get a license</a>';
				}else{
				}
			
		}
		}
	
		
		$content .= '<span class="media-title">'.get_the_title($post_id).'</span> ';
	  }else{
		  
	  }
	
	return $content;
	
}